<ui:composition
        xmlns:g="http://www.ihe.net/gazelle"
        xmlns:h="http://java.sun.com/jsf/html"
        xmlns:f="http://java.sun.com/jsf/core"
        xmlns:a4j="http://richfaces.org/a4j"
        xmlns:s="http://jboss.org/schema/seam/taglib"
        xmlns:ui="http://java.sun.com/jsf/facelets"
        xmlns:rich="http://richfaces.org/rich"
        xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        <h:outputScript library="jscript" name="jsf_updated.js" target="head"/>
        <s:div id="globalDiv" rendered="#{s:hasRole('admin_role')}">
            <div class="row">
                <div class="col-md-6">
                    <h:form id="globalform">

                        <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                            <ui:param name="styleClass" value="panel-info"/>
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.assertion-manager.EditScope']}"/>
                            </ui:define>

                            <s:token allowMultiplePosts="true"/>

                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['net.ihe.gazelle.assertion-manager.Keyword']}
                                </ui:define>
                                <ui:param name="id" value="scopeKey"/>
                                <h:inputText id="scopeKey" maxlength="32" size="32" styleClass="form-control"
                                             value="#{assertionScopeManager.selectedScope.keyword}"
                                             required="true">
                                </h:inputText>
                            </s:decorate>

                            <s:decorate template="/layout/form/_edit.xhtml">
                                <ui:define name="label">#{messages['net.ihe.gazelle.simulators.Description']}
                                </ui:define>
                                <ui:param name="id" value="desc"/>
                                <h:inputTextarea rows="4" cols="160" styleClass="form-control" id="desc"
                                                 value="#{assertionScopeManager.selectedScope.description}">
                                </h:inputTextarea>
                            </s:decorate>
                            <ui:define name="panel_footer">
                                <h:commandButton id="editScopePanelButton"
                                                 value="#{messages['gazelle.simulator.Save']}"
                                                 styleClass="gzl-btn-blue" style="width: 100px;"
                                                 action="#{assertionScopeManager.saveScope()}"
                                                 render="globalform,assertionLinkedForm"/>
                                <h:commandLink value="#{messages['users.Cancel']}" styleClass="gzl-btn"
                                               onclick="window.history.go(-1); return false;"/>
                            </ui:define>
                        </ui:decorate>
                    </h:form>
                </div>
                <div class="col-md-6">
                    <s:decorate id="summary" template="/layout/panels/_panel_title.xhtml">
                        <ui:param name="styleClass" value="panel-success"/>
                        <ui:define name="panel_title">
                            #{messages['net.ihe.gazelle.assertion-manager.Summary']}
                        </ui:define>
                        <ul class="list-group">
                            <li class="list-group-item"><span class="label label-success">#{assertionScopeManager.selectedScope.linkedScopes.size()}</span>
                                #{messages['net.ihe.gazelle.assertion-manager.LinkedScopes']}
                            </li>
                            <li class="list-group-item"><span class="label label-success">#{assertionScopeManager.selectedScope.assertions.size()}</span>
                                #{messages['net.ihe.gazelle.assertion-manager.DirectlyLinkedAssertions']}
                            </li>
                            <li class="list-group-item"><span class="label label-success">#{assertionScopeManager.selectedScope.getAllAssertions().size - assertionScopeManager.selectedScope.assertions.size()}</span>
                                #{messages['net.ihe.gazelle.assertion-manager.LinkedAssertionsThroughScopes']}
                            </li>
                            <li class="list-group-item"><span class="label label-success">#{assertionScopeManager.selectedScope.getAllAssertions().size}</span>
                                #{messages['net.ihe.gazelle.assertion-manager.TotalLinkedAssertions']}
                            </li>
                        </ul>
                    </s:decorate>
                </div>
            </div>
            <div class="row">
                <div class="col-md-6">
                    <h:form id="assertionLinkedForm" styleClass="form-horizontal">
                        <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                            <ui:param name="styleClass" value="panel-info"/>
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{assertionScopeManager.selectedScope.assertions.size()} #{messages['net.ihe.gazelle.assertion-manager.AssertionsDirectlyLinked']} "/>
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.assertion-manager.TotalOf']} #{assertionScopeManager.selectedScope.getAllAssertions().size} #{messages['net.ihe.gazelle.assertion-manager.AssertionsLinked']}"/>
                            </ui:define>
                            <div class="row">
                                <div class="col-lg-12">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter"
                                                  value="#{assertionScopeManager.assertionsLinkedFilter}"/>

                                        <ui:param name="filterId" value="idSchemeLinked"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.IdScheme']}"/>
                                        <ui:param name="filterForm" value="assertionLinkedForm"/>
                                    </ui:include>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-lg-12">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter"
                                                  value="#{assertionScopeManager.assertionsLinkedFilter}"/>

                                        <ui:param name="filterId" value="assertionIdLinked"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.assertion-manager.AssertionId']}"/>
                                        <ui:param name="filterForm" value="assertionLinkedForm"/>
                                    </ui:include>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-lg-12">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter"
                                                  value="#{assertionScopeManager.assertionsLinkedFilter}"/>

                                        <ui:param name="filterId" value="statusLinked"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.assertion-manager.Status']}"/>
                                        <ui:param name="filterForm" value="assertionLinkedForm"/>
                                    </ui:include>
                                </div>
                            </div>
                            <rich:dataTable rows="20" id="assertionLinked" var="assertion" rowKeyVar="rowId"
                                            value="#{assertionScopeManager.getAssertionsLinked()}">

                                <g:column sortBy="#{'target.idScheme'}" sortOrder="ascending">
                                    <ui:define name="header">#{messages['net.ihe.gazelle.IdScheme']}</ui:define>
                                    <h:outputLink
                                            title="#{messages['net.ihe.gazelle.assertion-manager.ViewIdScheme']} #{assertion.target.idScheme}"
                                            value="#{request.contextPath}/assertions/index.seam">
                                        <f:param name="idScheme" value="#{assertion.target.idScheme}"/>
                                        <h:outputText value="#{assertion.target.idScheme}"/>
                                    </h:outputLink>
                                </g:column>

                                <g:column sortBy="#{'assertionId'}" sortOrder="ascending">
                                    <ui:define name="header">#{messages['net.ihe.gazelle.AssertionId']}</ui:define>
                                    <h:outputLink
                                            title="#{messages['net.ihe.gazelle.assertion-manager.ViewAssertion']} #{assertion.assertionId}"
                                            value="#{request.contextPath}/assertions/show.seam">
                                        <f:param name="idScheme" value="#{assertion.target.idScheme}"/>
                                        <f:param name="assertionId" value="#{assertion.assertionId}"/>
                                        <h:outputText value="#{assertion.assertionId}"/>
                                    </h:outputLink>
                                </g:column>
                                <g:column id="assertionDescription">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.Predicate']}
                                    </ui:define>
                                    <h:outputText value="#{assertion.predicate.content}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:selectBooleanCheckbox id="selectAll"
                                                                 title="#{messages['net.ihe.gazelle.assertion-manager.SelectAll']}"
                                                                 onclick="checkAllCheckboxesInTable( this.id, this.checked );"/>
                                        <h:outputText value="#{messages['net.ihe.gazelle.simulators.All']}"/>
                                    </ui:define>
                                    <h:selectBooleanCheckbox
                                            value="#{assertionScopeManager.checkedAssertionsToRemove[assertion.id]}"/>
                                </g:column>

                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="dsLinked"/>
                                        <ui:param name="dataTableId" value="assertionLined"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                            <ui:define name="panel_footer">
                                <a4j:commandButton id="removeAssertionFromScope"
                                                   value="#{messages['net.ihe.gazelle.assertion-manager.RemoveSelectionFromScope']}"
                                                   immdediate="true"
                                                   styleClass="gzl-btn-red"
                                                   oncomplete="document.getElementById('assertionLinkedForm:assertionLinked:selectAll').checked=false;location.reload();"
                                                   actionListener="#{assertionScopeManager.removeAssertionFromScope()}"
                                                   render="assertionLinkedForm,assertionsAvailableForm,summary"/>
                            </ui:define>
                        </ui:decorate>
                    </h:form>
                </div>
                <div class="col-md-6">
                    <h:form id="assertionsAvailableForm" styleClass="form-horizontal">
                        <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.assertion-manager.LinkAssertionToTheScope']}"/>
                            </ui:define>
                            <div class="row">
                                <div class="col-lg-12">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter"
                                                  value="#{assertionScopeManager.possibleAssertionsToAddFilter}"/>

                                        <ui:param name="filterId" value="idScheme"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.IdScheme']}"/>
                                        <ui:param name="filterForm" value="assertionsAvailableForm"/>
                                    </ui:include>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-lg-12">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter"
                                                  value="#{assertionScopeManager.possibleAssertionsToAddFilter}"/>

                                        <ui:param name="filterId" value="assertionId"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.assertion-manager.AssertionId']}"/>
                                        <ui:param name="filterForm" value="assertionsAvailableForm"/>
                                    </ui:include>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-lg-12">
                                    <ui:include src="/filter/filter.xhtml">
                                        <ui:param name="filter"
                                                  value="#{assertionScopeManager.possibleAssertionsToAddFilter}"/>

                                        <ui:param name="filterId" value="status"/>
                                        <ui:param name="filterName"
                                                  value="#{messages['net.ihe.gazelle.assertion-manager.Status']}"/>
                                        <ui:param name="filterForm" value="assertionsAvailableForm"/>
                                    </ui:include>
                                </div>
                            </div>

                            <rich:dataTable rows="20" id="assertion" var="assertion" rowKeyVar="rowId"
                                            value="#{assertionScopeManager.getPossibleAssertionsToAdd()}">

                                <g:column sortBy="#{'target.idScheme'}" sortOrder="ascending">
                                    <ui:define name="header">#{messages['net.ihe.gazelle.IdScheme']}</ui:define>
                                    <h:outputLink
                                            title="#{messages['net.ihe.gazelle.assertion-manager.ViewIdScheme']} #{assertion.target.idScheme}"
                                            value="#{request.contextPath}/idSchemes/index.seam">
                                        <f:param name="idScheme" value="#{assertion.target.idScheme}"/>
                                        <h:outputText value="#{assertion.target.idScheme}"/>
                                    </h:outputLink>
                                </g:column>

                                <g:column sortBy="#{'assertionId'}" sortOrder="ascending">
                                    <ui:define name="header">#{messages['net.ihe.gazelle.AssertionId']}</ui:define>
                                    <h:outputLink
                                            title="#{messages['net.ihe.gazelle.assertion-manager.ViewAssertion']} #{assertion.assertionId}"
                                            value="#{request.contextPath}/assertions/show.seam">
                                        <f:param name="idScheme" value="#{assertion.target.idScheme}"/>
                                        <f:param name="assertionId" value="#{assertion.assertionId}"/>
                                        <h:outputText value="#{assertion.assertionId}"/>
                                    </h:outputLink>
                                </g:column>
                                <g:column id="assertionDescription">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.Predicate']}
                                    </ui:define>
                                    <h:outputText value="#{assertion.predicate.content}"/>
                                </g:column>

                                <g:column>
                                    <ui:define name="header">
                                        <h:selectBooleanCheckbox id="selectAll"
                                                                 title="#{messages['net.ihe.gazelle.assertion-manager.SelectAll']}"
                                                                 onclick="checkAllCheckboxesInTable( this.id, this.checked );"/>
                                        <h:outputText value="#{messages['net.ihe.gazelle.simulators.All']}"/>
                                    </ui:define>
                                    <h:selectBooleanCheckbox
                                            value="#{assertionScopeManager.checked[assertion.id]}"/>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="ds"/>
                                        <ui:param name="dataTableId" value="assertion"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>

                            <ui:define name="panel_footer">
                                <a4j:commandButton id="addToScope"
                                                   value="#{messages['net.ihe.gazelle.assertion-manager.AddSelectionToScope']}"
                                                   immdediate="true"
                                                   styleClass="gzl-btn-blue"
                                                   oncomplete="document.getElementById('assertionsAvailableForm:assertion:selectAll').checked=false;location.reload();"
                                                   actionListener="#{assertionScopeManager.addToScope()}"
                                                   render="assertionLinkedForm,assertionsAvailableForm,summary"/>
                            </ui:define>
                        </ui:decorate>
                    </h:form>
                </div>
            </div>

            <h:form id="linkedScopesForm" rendered="#{assertionScopeManager.selectedScope.getId() != null}"
                    styleClass="form-horizontal">
                <s:token allowMultiplePosts="true"/>
                <div class="row">
                    <div class="col-md-6">
                        <ui:decorate template="/layout/panels/_panel_title.xhtml">
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.assertion-manager.ThisScopeIsLinkedToThoseOtherScopes']}"/>
                            </ui:define>
                            <rich:dataTable rows="20" id="linkedScopeTable" var="scope"
                                            value="#{assertionScopeManager.selectedScope.linkedScopes}"
                                            render="scopeTableDs">
                                <g:column id="scopeKeyword" sortBy="#{'keyword'}"
                                          sortOrder="ascending">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.Keyword']}
                                    </ui:define>
                                    <h:outputText value="#{scope.keyword}"/>
                                </g:column>
                                <g:column id="scopeDescription">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.simulators.Description']}
                                    </ui:define>
                                    <h:outputText value="#{scope.description}"/>
                                </g:column>
                                <g:column id="nbAssertions">
                                    <ui:define name="header">##{messages['net.ihe.gazelle.Assertions']}
                                    </ui:define>
                                    <h:outputText value="#{scope.getAllAssertions().size}"/>
                                </g:column>
                                <g:column id="actions">
                                    <ui:define name="header">#{messages['net.ihe.gazelle.Actions']}</ui:define>
                                    <a4j:commandLink immediate="true"
                                                     actionListener="#{assertionScopeManager.unlinkScope(scope)}"
                                                     oncomplete="location.reload();"
                                                     title="#{messages['net.ihe.gazelle.assertion-manager.UnlinkScope']}"
                                                     render="linkedScopesForm,assertionLinkedForm,summary">
                                        <span class="gzl-icon-trash-o"/>
                                    </a4j:commandLink>
                                </g:column>
                            </rich:dataTable>
                        </ui:decorate>
                    </div>
                    <div class="col-md-6">
                        <ui:decorate template="/layout/panels/_panel_title_footer.xhtml">
                            <ui:param name="styleClass" value="panel-info"/>
                            <ui:define name="panel_title">
                                <h:outputText
                                        value="#{messages['net.ihe.gazelle.assertion-manager.LinkScopeToTheScope']}"/>
                            </ui:define>
                            <h:outputText
                                    value="#{messages['net.ihe.gazelle.assertion-manager.TheScopeWillInheritAssertionsFromLinkedScopes']}"/>

                            <rich:dataTable rows="20" id="scopeTable" var="scope"
                                            value="#{assertionScopeManager.scopes}"
                                            render="scopeTableDs">
                                <g:column id="scopeKeyword" sortBy="#{'keyword'}"
                                          sortOrder="ascending">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.assertion-manager.Keyword']}
                                    </ui:define>
                                    <h:outputText value="#{scope.keyword}"/>
                                </g:column>
                                <g:column id="scopeDescription">
                                    <ui:define name="header">
                                        #{messages['net.ihe.gazelle.simulators.Description']}
                                    </ui:define>
                                    <h:outputText value="#{scope.description}"/>
                                </g:column>
                                <g:column id="nbAssertions">
                                    <ui:define name="header">##{messages['net.ihe.gazelle.Assertions']}
                                    </ui:define>
                                    <h:outputText value="#{scope.getAllAssertions().size}"/>
                                </g:column>
                                <g:column>
                                    <ui:define name="header">
                                        <h:selectBooleanCheckbox id="selectAll"
                                                                 title="#{messages['net.ihe.gazelle.assertion-manager.SelectAll']}"
                                                                 onclick="checkAllCheckboxesInTable( this.id, this.checked );"/>
                                        <h:outputText value="#{messages['net.ihe.gazelle.simulators.All']}"/>
                                    </ui:define>
                                    <h:selectBooleanCheckbox
                                            value="#{assertionScopeManager.checkedScopeLinkToRemove[scope.id]}"/>
                                </g:column>
                                <f:facet name="footer">
                                    <ui:include src="/util/datatableFooter.xhtml">
                                        <ui:param name="dataScrollerId" value="scopeTableDs"/>
                                        <ui:param name="dataTableId" value="scopeTable"/>
                                        <ui:param name="hideRowsSelect" value="true"/>
                                        <ui:param name="maxPages" value="5"/>
                                    </ui:include>
                                </f:facet>
                            </rich:dataTable>
                            <ui:define name="panel_footer">
                                <a4j:commandButton id="linkScopeToScope"
                                                   value="#{messages['net.ihe.gazelle.assertion-manager.LinkSelectionToScope']}"
                                                   immdediate="true"
                                                   styleClass="gzl-btn-blue"
                                                   oncomplete="document.getElementById('linkedScopesForm:scopeTable:selectAll').checked=false;location.reload();"
                                                   actionListener="#{assertionScopeManager.linkScopeToThisScope()}"
                                                   render="linkedScopesForm,assertionLinkedForm,summary"/>
                            </ui:define>
                        </ui:decorate>
                    </div>
                </div>
            </h:form>

        </s:div>
    </ui:define>
</ui:composition>
